
var generators = require('yeoman-generator');
var glob = require('glob');

module.exports = generators.Base.extend({
  constructor: function() {
    generators.Base.apply(this, arguments);

    // need a directory to scaffold from
    this.argument('srcDir', {type:String, required: true});
    // TODO: ensure this exists
  },

  default: function() {
    this.composeWith('generator');
  },

  writing: function() {
    var srcDir = this.srcDir;
    // we don't use this file
    this.fs.delete(this.destinationPath('generators/app/templates/dummyfile.txt'));

    // copy everything from the directory to a staic files location
    this.fs.copy(srcDir + '/**', this.destinationPath('generators/app/templates/'));

    var files = glob.sync(srcDir + '/**');
    var fileList = files.map(function(f) {
      // remove the prefix
      return f.substr(srcDir.length);
    }).filter(function(f) {
      return f.length > 0;
    });

    this.fs.copyTpl(
      this.templatePath('index.js'), 
      this.destinationPath('generators/app/index.js'),
      {files: fileList}
    );
  }
});

